/* main.c     	Monitor Test Patterns   Rev 1.1

  (C) Copyright 1998, 2001  Jed Margolin

  Permission is given for individuals to use this code for their own use
  as long as credit is given to the author.

  Any commercial use requires permission of the author.


  Add egavga.obj and litt.obj to the project files. If they do not already
  exist in \BC\BGI you create them (in \BC\BGI)	by running: 
		bgiobj egavga.bgi
		bgiobj litt.chr

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include "mtable.h"

#define FALSE (0)
#define TRUE  (1)
#define NUMLINES 25
#define NUMCOLS 80
#define RETURN 13
#define UPARROW 72
#define DOWNARROW 80
#define ESC 27
#define FK1 59

extern void cbarpgm(void),cbarpgm2(void),dots(void);
extern sine1(void),sine2(void),chatch(void),hvtest(void);
void interrupt (*oldbreak)(void);
int break_flag;
char path[50];

void draw_menu(void), update_menu(void), print_header(void);
void hide_cursor(void);
void interrupt isr_break(void);
void wait_tics(int);
void mexit(void),directions(void);

char quit=FALSE ;
char first_update=TRUE ;
int  main_sel;
// ========================================================================
// ========================================================================
int main(int argc, char *argv[], char *env[])
{
	char c;
//-------------------------------------------------------------------------
	main_sel=0 ;
	printf("[s");		// save the cursor position
	_setcursortype(_NOCURSOR);
//-------------------------------------------------------------------------
// Save the old Keyboard Break Interrupt and put in our own
	break_flag = 0;
	oldbreak = getvect(0x1b);

	setvect(0x1b,isr_break) ;	// New Interrupt for Keyboard Break
// ------------------------------------------------------------------------
	clrscr();
// ------------------------------------------------------------------------
	draw_menu();
// ------------------------------------------------------------------------
// Read and process keyboard
	while(!(quit))
	{
		update_menu() ;
		c = getch() ;
		if (!c) c = getch() ;	// get second byte if cursor key
		switch (c)
		{
	 case UPARROW:
		 main_sel -= 1;
		 if (main_sel<0)   { main_sel = NUM_ENTRIES -1; }
		 break;

	 case DOWNARROW:
		 main_sel += 1;
		 main_sel %= NUM_ENTRIES;
		 break;

	 case RETURN:
		 (mtable[main_sel].pgm() );
		 clrscr();
		 draw_menu();
		 break;

	 case FK1:
		 directions();
		 clrscr();
		 draw_menu();
		 break;

	 case ESC:
		 mexit();
		 break;
		}		// end switch

	}		// end while

// That's the news and we are outa here
	setvect(0x1b,oldbreak);	// Restore the old Keyboard Break Interrupt
	textcolor(LIGHTGRAY);
	textbackground(BLACK);
	clrscr();
	_setcursortype(_NORMALCURSOR);
	printf("[u");		// restore the cursor
	gotoxy(1,1);
	return 0 ;
}				// end main
// ========================================================================
// ========================================================================
// Redraw the Main Menu
void draw_menu()
{
	int i;

	clrscr();
	print_header();

	textcolor(2);
	for (i=0 ; i<NUM_ENTRIES ; i++)
	{
	gotoxy(mtable[i].xpos,mtable[i].ypos);
	cprintf("%s",mtable[i].msg) ;
	}
	textcolor(2);

	gotoxy(XM1,21);
	printf("Press UP Arrow and DOWN Arrow to navigate the menu.");
	gotoxy(XM1,22);
	printf("Press Enter to make a selection.");
	gotoxy(XM1,24);
	printf("Press F1 for Help.");

	hide_cursor();
}
// ========================================================================
// Make selected Menu Entry Reverse
void update_menu()
{
	static int oldsel ;

	if (first_update)
	{
	oldsel = main_sel ;
	first_update = FALSE ;
	}

// normal color
	textcolor(2);
	textbackground(0);
	gotoxy(mtable[oldsel].xpos,mtable[oldsel].ypos);
	cprintf("%s",mtable[oldsel].msg);

// reverse color
	textcolor(0);
	textbackground(2);
	gotoxy(mtable[main_sel].xpos,mtable[main_sel].ypos);
	cprintf("%s",mtable[main_sel].msg);

	textcolor(2);
	textbackground(0);

	oldsel = main_sel;
	hide_cursor();
}
// ========================================================================
// mexit - EXIT routine
void mexit()
{
	quit = TRUE ;
}
// ========================================================================
// Hide the cursor by placing it at an off screen location
void hide_cursor()
{
	textcolor(BLACK);
	gotoxy(78,24);
}
// ========================================================================
void print_header()
{
	gotoxy(XM1,2) ;
	printf("VGA Monitor Test Patterns      V1.1              pNambic Systems");
	gotoxy(XM1,3) ;
	printf("(C) Copyright 1998, 2001   Jed Margolin      All Rights Reserved");
}
// ========================================================================
// interrupt service routine from break key
void interrupt isr_break(void)
{
	break_flag = 1;
}
// ========================================================================
// Wait n tics
void wait_tics(int n)
{
	long m1,m2;

	n = n++;
	m1 = biostime(0,0);		/* what time is it now? */
	m2 = m1;
	while( abs(m2-m1) < n)	{ m2 = biostime(0,0); }
}
// ========================================================================
//========================================================================
// Lissajous #1 (Lines)
void pgm1()
{
	clrscr();
	sine1();
}
//========================================================================
// Lissajous #2 (Points)
void pgm2()
{
	clrscr();
	sine2();
}
//========================================================================
// Color Bars #1
void pgm3()
{
	clrscr();
	cbarpgm();
}
//========================================================================
// Color Bars #2
void pgm4()
{
	clrscr();
	cbarpgm2();
}
// ========================================================================
// Cross Hatch
void pgm5()
{
	clrscr();
	chatch();
}
// ========================================================================
// Dots
void pgm6()
{
	clrscr();
	dots();
}
//========================================================================
// High Voltage Regulation Test
void pgm7()
{
	clrscr();
	hvtest();
}
// ========================================================================
void directions()
{
	int n;

	clrscr();

	for(n=0; n<18; n++)
	{
		gotoxy(dirmsgs[n].xpos,dirmsgs[n].ypos);
		textcolor(dirmsgs[n].color);
		cprintf("%s",dirmsgs[n].msg);
	}
	hide_cursor();
	getch();
}
//========================================================================

